/*
 * Extjs common functions 
 * @by: francis.barretto
 * @date: 2009-08-19  
 */

/*
 *  ExtCommon.util.METHOD_NAME  
 */

Ext.namespace("ExtCommon");
ExtCommon.util = function(){
	return {
		init: function(){
		Ext.BLANK_IMAGE_URL = '/js/ext34/resources/images/default/s.gif';
			Ext.form.TextField.prototype.size = 10;
			Ext.form.TextField.prototype.initValue = function()
			{
				if(this.value !== undefined){
				    this.setValue(this.value);
				}else if(this.el.dom.value.length > 0){
			    	this.setValue(this.el.dom.value);
				}
				this.el.dom.size = this.size;
				if (!isNaN(this.maxLength) && (this.maxLength *1) > 0 && (this.maxLength != Number.MAX_VALUE)) {
			    	this.el.dom.maxLength = this.maxLength *1;
				}
			};
		},		
		/*
		 * 	@description: renders the search field object. 
		 * 	creates Ext.app.SearchField Object
		 *
		 *   usage: ExtCommon.util.renderSearchField();
		 *   Ext Property [tbar]
		 *   tbar: [ new Ext.app.SearchField({ store: Objstore, width:320}) ]
		 *   return (void)
		 */
		
		createCombo: function(id, hidden, anchor, url, label, blank, read){
			return {
			xtype:'combo',
			id: id,
			hiddenName: hidden,
            hiddenId: hidden,
			name: id,
			valueField: 'id',
			displayField: 'name',
			anchor: anchor,
			triggerAction: 'all',
			minChars: 2,
			forceSelection: true,
			enableKeyEvents: true,
			pageSize: 10,
			resizable: true,
			readOnly: read,
			minListWidth: 300,
			allowBlank: blank,
			store: new Ext.data.JsonStore({
			id: 'idsocombo',
			root: 'data',
			totalProperty: 'totalCount',
			fields:[{name: 'id'}, {name: 'name'}],
			url: url,
			baseParams: {start: 0, limit: 10}

			}),
			listeners: {
            beforequery: function(qe)
			{
                       delete qe.combo.lastQuery;
                                
			},

			select: function (combo, record, index){
			this.setRawValue(record.get('name'));
			Ext.get(this.hiddenName).dom.value  = record.get('id');
			},
			blur: function(){
			var val = this.getRawValue();
			this.setRawValue.defer(1, this, [val]);
			this.validate();
			},
			render: function() {
			this.el.set({qtip: 'Type at least ' + this.minChars + ' characters to search for a'+this.fieldLabel});

			},
			keypress: {buffer: 100, fn: function() {
			Ext.get(this.hiddenName).dom.value  = '';
			if(!this.getRawValue()){
			this.doQuery('', true);
			}
			}}
			},
			fieldLabel: label

			}
		},
		
		renderSearchField: function(querybyid){				
				Ext.app.SearchField = Ext.extend(Ext.form.TwinTriggerField, {
				    initComponent : function(){
				        Ext.app.SearchField.superclass.initComponent.call(this);
				        this.on('specialkey', function(f, e){
				            if(e.getKey() == e.ENTER){
				                this.onTrigger2Click();
				            }
				        }, this);
				    },
				    validationEvent:false,
				    validateOnBlur:false,
				    trigger1Class:'x-form-clear-trigger',
				    trigger2Class:'x-form-search-trigger',
				    hideTrigger1:true,
				    width:180,
				    hasSearch : false,
				    paramName : 'query',
				    paramBy : 'queryby',
				    onTrigger1Click : function(){
				        if(this.hasSearch){
				            this.el.dom.value = '';
				            var o = {start: 0};
				            this.store.baseParams = this.store.baseParams || {};
				            this.store.baseParams[this.paramName] = '';
				            this.store.reload({params:o});
				            this.triggers[0].hide();
				            this.hasSearch = false;				            
				        }
				    },
				    onTrigger2Click : function(){
				        var v = this.getRawValue();
				        if(v.length < 1){
				            this.onTrigger1Click();
				            return;
				        }
				        var o = {start: 0};
				        this.store.baseParams = this.store.baseParams || {};
				        this.store.baseParams[this.paramName] = v;
				        this.store.baseParams['queryby'] = Ext.getCmp(querybyid).getValue();
				        this.store.reload({params:o});
				        this.hasSearch = true;
				        this.triggers[0].show();
				    }
			});		
		},
		
		/*
		 * 	@description: this method will validate the selection grid / if the user really clicks a record
		 *  @usage: 
		 *  
		 *  	if(!ExtCommon.util.validateSelectionGrid(ObjId))
		 * 			return;
		 *  returns boolean (false shows warning msg) 		
		 */
		
				
		validateSelectionGrid: function(ObjGrid, msg){						
			 
			var sm = Ext.getCmp(ObjGrid).getSelectionModel();
			if(!msg)
				msg = "Please select a record!";
			if (!sm.hasSelection()){
				Ext.Msg.show({ title: 'Warning!', msg: msg,icon: Ext.Msg.WARNING,	buttons: Ext.Msg.OK});			                
				return false;
			}
			
			return true;				
		},
		
		/*
		 * 	@descirption: this method will validate the form if there is any required fields missed.
		 *  @usage: ExtCommon.util.validateFormFields(ObjForm)
		 *  return boolean (false prompt error message);  
		 */				
		
		validateFormFields: function(ObjForm){
			
			if(!ObjForm.form.isValid()){
				Ext.Msg.show({title: 'Error!',	msg: "Please fill-in/correct the fields (Marked red).",icon: Ext.Msg.ERROR,buttons: Ext.Msg.OK	});
				return false;
			}
			return true;
		},
		
		/*
		 * 	@description: enable markers tips on forms (creates object for tooltips)
		 *  @usage: ExtCommon.util.quickTips();
		 *  return (void)		  	
		 */
		
		quickTips: function(){
			
			Ext.QuickTips.init(); 	  
				// invalid markers to sides 
				Ext.form.Field.prototype.msgTarget = 'side'; 				    
			  	Ext.form.TextField.prototype.size = 10;
				Ext.form.TextField.prototype.initValue = function()
				{
				    if(this.value !== undefined){
				        this.setValue(this.value);
				    }else if(this.el.dom.value.length > 0){
				        this.setValue(this.el.dom.value);
				    }
				    this.el.dom.size = this.size;
				    if (!isNaN(this.maxLength) && (this.maxLength *1) > 0 && (this.maxLength != Number.MAX_VALUE)) {
				        this.el.dom.maxLength = this.maxLength *1;
				    }				        
				};
		},
		
		/*		  
		 *  @description: Reloads grid data
		 *  @usage: ExtCommon.util.refreshGrid(objGrid);
		 *  return (void)
		 */
		
		refreshGrid: function(objGrid){
			Ext.getCmp(objGrid).getStore().reload();
		},
		
		validations: function(){
		Ext.apply(Ext.form.VTypes, {
			
		daterange : function(val, field) {
        var date = field.parseDate(val);

        if(!date){
            return;
        }
        if (field.startDateField && (!this.dateRangeMax || (date.getTime() != this.dateRangeMax.getTime()))) {
            var start = Ext.getCmp(field.startDateField);
            start.setMaxValue(date);
            start.validate();
            this.dateRangeMax = date;
        } 
        else if (field.endDateField && (!this.dateRangeMin || (date.getTime() != this.dateRangeMin.getTime()))) {
            var end = Ext.getCmp(field.endDateField);
            end.setMinValue(date);
            end.validate();
            this.dateRangeMin = date;
        }
        /*
         * Always return true since we're only using this vtype to set the
         * min/max allowed values (these are tested for after the vtype test)
         */
        return true;
    },
    
    timerange : function(val, field) {
    	var time = field.parseDate(val);
    	if(!time){
    	return;
    	}
    	if (field.startTimeField && (!this.timeRangeMax || (time.getTime() != this.timeRangeMax.getTime()))) {
    	var start = Ext.getCmp(field.startTimeField);
    	start.setMaxValue(time);
    	start.validate();
    	this.timeRangeMax = time;
    	}
    	else if (field.endTimeField && (!this.timeRangeMin || (time.getTime() != this.timeRangeMin.getTime()))) {
    	var end = Ext.getCmp(field.endTimeField);
    	end.setMinValue(time);
    	end.validate();
    	this.timeRangeMin = time;
    	}
    	return true;
    	},
   

    	password : function(val, field) {
        	if (field.initialPassField) {
           	 var pwd = Ext.getCmp(field.initialPassField);
           	 return (val == pwd.getValue());
       		 }
       	 return true;
    	},

    	passwordText : 'Passwords do not match',
    	
    	age: function(val, field) {
        	if (field.initialAge) {
           	 var age = Ext.getCmp(field.initialAge);
           	 return (val >= age.getValue());
       		 }
       	 return true;
    	},
    	
    	ageText: 'This field must be greater than or equal to \'From Age\''
		});

		}
	}	
}();